;;; $Id: kScheme.tst,v 1.2 1996/09/21 09:34:18 queinnec Exp $

(parallel 1 2)
   (multiple 1 2)
(+ 1 (parallel 1 2))
   (multiple 2 3)
(+ 1 (parallel 33 (suicide)))
   (multiple 34)
((lambda (//iota)
   (set! //iota (lambda (start stop)
                  (if (< start stop)
                      (parallel start (//iota (+ start 1) stop))
                      (suicide) ) ))
   (list (//iota 0 9)) )
 '//iota )
   (multiple (0) (1) (2) (3) (4) (5) (6) (7) (8))
((lambda (walk)
   (set! walk (lambda (tree)
                (if (pair? tree)
                    (parallel (walk (car tree))
                              (walk (cdr tree)) )
                    (if (null? tree) (suicide) tree) ) ))
   (parallel (walk '(a (b . c) ((d e) . f) . g))
             (walk '(((1 . 2) 3 (4 5) . 6) 7 8)) ) )
 'walk )
   (multiple 1 2 3 4 5 6 7 8 a b c d e f g)

(parallel 1 (begin (sleep 10) 2) (begin (sleep 50) 3))
   (multiple 1 2 3)
((lambda (f)
   (touch f) )
 (future 11) )
   11
((lambda (f)
   (touch f) )
 (future (begin (sleep 10) 12)) )
   12
((lambda (f)
   (sleep 100)
   (touch f) )
 (future (begin (sleep 10) 12)) )
   12
((lambda (fib)
   (set! fib (lambda (n)
               (if (< n 2) 
                   n
                   ((lambda (fibn-1 fibn-2)
                      (+ (touch fibn-2) (touch fibn-1)) )
                    (future (fib (- n 1)))
                    (future (fib (- n 2))) ) ) ))
   (fib 10) )
 'fib )
   55

;;; Testing channels
(channel-create)
   ---
((lambda (c)
   (parallel 
    (begin (sleep 10) (channel-receive c))
    (begin (channel-send c 'a) (suicide)) ) )
 (channel-create) )
   a
((lambda (c)
   (parallel 
    (begin (channel-receive c))
    (begin (sleep 10) (channel-send c 'a) (suicide)) ) )
 (channel-create) )
   a
((lambda (c)
   (parallel 
    (begin (sleep 10) (channel-receive c))
    (begin (sleep 10) (channel-receive c))
    (begin (channel-send c 'a) (suicide))
    (begin (channel-send c 'b) (suicide)) ) )
 (channel-create) )
   (multiple a b)
((lambda (c)
   (parallel 
    (begin (channel-receive c))
    (begin (channel-receive c))
    (begin (sleep 10) (channel-send c 'a) (suicide))
    (begin (sleep 10) (channel-send c 'b) (suicide)) ) )
 (channel-create) )
   (multiple a b)

;;; end of kScheme.tst
